var WpvMouse = {
    dragObject: null,
    mouseOffset: null,

    mouseCoords: function(ev) {
        if (ev.pageX || ev.pageY) {
            return {x:ev.pageX, y:ev.pageY};
        }
        return {
            x:ev.clientX + ScrollXY.getX() - document.body.clientLeft,
            y:ev.clientY + ScrollXY.getY()  - document.body.clientTop
        };
    },

    makeClickable: function(object) {
            object.onmousedown = function(){
                WpvMouse.dragObject = this;
            }
    },

    getMouseOffset: function(target, ev) {
            ev = ev || window.event;

            var docPos    = WpvMouse.getPosition(target);
            var mousePos  = WpvMouse.mouseCoords(ev);
            return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
    },

    getPosition: function(e) {
            var left = 0;
            var top  = 0;

            while (e.offsetParent){
                left += e.offsetLeft;
                top += e.offsetTop;
                e = e.offsetParent;
            }

            left += e.offsetLeft;
            top  += e.offsetTop;

            return {x:left, y:top};
    },

    mouseMove: function(ev) {
        ev = ev || window.event;
        var mousePos = WpvMouse.mouseCoords(ev);

        if (WpvMouse.dragObject) {
            WpvMouse.dragObject.style.position = 'absolute';
            WpvMouse.dragObject.style.top = mousePos.y - WpvMouse.mouseOffset.y + "px";
            WpvMouse.dragObject.style.left = mousePos.x - WpvMouse.mouseOffset.x + "px";

            return false;
        }
},

mouseUp: function() {
        WpvMouse.dragObject = null;
},

makeDraggable: function(item) {
        if(!item) return;
        
        document.onmousemove = WpvMouse.mouseMove;
        document.onmouseup = WpvMouse.mouseUp;

        item.style.cursor = "move";
        item.onmousedown = function(ev) {
            WpvMouse.dragObject  = this;
            WpvMouse.mouseOffset = WpvMouse.getMouseOffset(this, ev);
            return false;
        }
}
}

var WpvTooltip = {
    timeOutId: 0,
    xmlRequest: new XmlRequest(),
    cache: new Array(),
    
    move: function (e) {
        var oTooltip;
        
        if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
            e = e || window.event;
            var oCoords = WpvMouse.mouseCoords(e);
            
            oTooltip.style.left = oCoords.x + 10 + "px";
            oTooltip.style.top = oCoords.y + 10 + "px";
        }
    },
    
    show: function(e, oText) {
        e = e || window.event;

        var oTooltip;
        var oCoords = WpvMouse.mouseCoords(e);
        var oTarget = WpvTooltip.getTarget(e);
        
        if ((oTooltip = document.getElementById("wpv-tooltip")) == null) {
            oTooltip = document.createElement("div")
            oTooltip.setAttribute("id", "wpv-tooltip")

            document.body.appendChild(oTooltip)
        }
        oTooltip.innerHTML = oText;
        WpvTooltip.move(e);
        
        if (oTooltip.style.display == "inline")
            oTooltip.style.display = "none";
        
        oTarget.onmouseout = WpvTooltip.hide;
        oTarget.onmousemove = WpvTooltip.move;
        
        WpvTooltip.timeOutId = setTimeout(
            function() {
                var oTooltip;
                if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
                    oTooltip.style.display = "inline";
                }
            }, 1000
        );
    },

    hide: function(e) {
        e = e || window.event;

        if (WpvTooltip.timeOutId > 0) {
            clearTimeout(WpvTooltip.timeOutId);
            WpvTooltip.timeOutId = 0;
        }
        WpvTooltip.getTarget(e).style.cursor = "default";

        setTimeout(
            function() {
                var oTooltip;
                if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
                    oTooltip.style.display = "none";
                }
            }, 500
        );
    },
    
    load: function(e, sUri, sId) {
        e = e || window.event;

        var oTooltip;
        var oCoords = WpvMouse.mouseCoords(e);
        var oTarget = WpvTooltip.getTarget(e);
        
        if ((oTooltip = document.getElementById("wpv-tooltip")) == null) {
            oTooltip = document.createElement("div")
            oTooltip.setAttribute("id", "wpv-tooltip")
            document.body.appendChild(oTooltip)
        }
        WpvTooltip.move(e);
        
        if (oTooltip.style.display == "inline")
            oTooltip.style.display = "none";
        
        oTarget.onmouseout = WpvTooltip.hide;
        oTarget.onmousemove = WpvTooltip.move;
        
        WpvTooltip.timeOutId = setTimeout(
            function() {
                var oTooltip;
                if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
                    var oParameters = new XmlRequestParameters();
                    
                    oParameters.add("wpv-tooltip", sId);
                    if (WpvTooltip.cache[oParameters.getParameters()] == null) {
                        WpvTooltip.xmlRequest.cancelRequest();
                        WpvTooltip.xmlRequest.requestUri = sUri;
                        WpvTooltip.xmlRequest.onRequestSent = WpvTooltip.doRequestSent;
                        WpvTooltip.xmlRequest.onSuccess = WpvTooltip.doRequestSuccess;
                        WpvTooltip.xmlRequest.onFailed = WpvTooltip.doRequestFailed;
                        WpvTooltip.xmlRequest.onTimeOut = WpvTooltip.doRequestFailed;
                        WpvTooltip.xmlRequest.onCanceled = WpvTooltip.doRequestFailed;
                        
                        WpvTooltip.xmlRequest.sendPostRequest(oParameters);
                    }
                    else {
                        oTooltip.innerHTML = WpvTooltip.cache[oParameters.getParameters()];
                    }
                    oTooltip.style.display = "inline";
                }
            }, 1000
        );
    },
    
    doRequestSent: function() {
        var oTooltip;
        if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
            oTooltip.innerHTML = "Loading...";
        }
    },
    
    doRequestSuccess: function(oRequest, iStatus, sStatusText) {
        var oTooltip;
        if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
            oTooltip.innerHTML = oRequest.getResponseText();
            WpvTooltip.cache[oRequest.parameters] = oRequest.getResponseText();
        }
    },
    
    doRequestFailed: function() {
        var oTooltip;
        if ((oTooltip = document.getElementById("wpv-tooltip")) != null) {
            oTooltip.innerHTML = "Failed to load the tooltip";
        }
    },
    
    getTarget: function(e) {
        var oTarget;

        if (e.target) 
            oTarget = e.target;
        else if (e.srcElement) 
            oTarget = e.srcElement;
            
        if (oTarget.nodeType == 3) // defeat Safari bug
            return oTarget.parentNode;
            
        return oTarget;
    }
}

var WpvPopup = {
    xmlRequest: new XmlRequest(),
    cache: new Array(),
    className: null,
    offsetLeft: 0,
    offsetTop: 0,
    canMove: true,

    getPopup: function() {
        var oPopup;
        
        if ((oPopup = document.getElementById("wpv-popup")) == null) {
            oPopup = document.createElement("div");
            oPopup.setAttribute("id", "wpv-popup");

            if (WpvPopup.className != null)
                oPopup.className = WpvPopup.className;

            document.body.appendChild(oPopup);
        }
        return oPopup;
    },
    
    updateText: function(sText) {
        var oPopup;
        
        if ((oPopup = document.getElementById("wpv-popup")) != null) {
            oPopup.innerHTML = sText;
            oPopup.style.display = "inline";
        }
    },
    
    show: function(sText) {
        var oPopup;
        
        oPopup = WpvPopup.getPopup();
        oPopup.innerHTML = sText;
        oPopup.style.left = WpvPopup.offsetLeft + "px";
        oPopup.style.top = WpvPopup.offsetTop + "px";
        oPopup.style.display = "inline";
        if (WpvPopup.canMove)
            WpvMouse.makeDraggable(oPopup);
    },

    hide: function() {
        var oPopup;

        if ((oPopup = document.getElementById("wpv-popup")) != null) {
            oPopup.style.display = "none";
        }
    },
    
    load: function(sUri, sId) {
        var oPopup;
        var oParameters = new XmlRequestParameters();
        
        if ((oPopup = document.getElementById("wpv-popup")) == null) {
            oPopup = document.createElement("div")
            oPopup.setAttribute("id", "wpv-popup")

            document.body.appendChild(oPopup)
        }
        
        oParameters.add("wpv-popup", sId);
        if (WpvPopup.cache[oParameters.getParameters()] == null) {
            WpvPopup.xmlRequest.cancelRequest();
            WpvPopup.xmlRequest.requestUri = sUri;
            WpvPopup.xmlRequest.onRequestSent = WpvPopup.doRequestSent;
            WpvPopup.xmlRequest.onSuccess = WpvPopup.doRequestSuccess;
            WpvPopup.xmlRequest.onFailed = WpvPopup.doRequestFailed;
            WpvPopup.xmlRequest.onTimeOut = WpvPopup.doRequestFailed;
            WpvPopup.xmlRequest.onCanceled = WpvPopup.doRequestFailed;
            
            WpvPopup.xmlRequest.sendPostRequest(oParameters);
        }
        else {
            oPopup.innerHTML = WpvTooltip.cache[oParameters.getParameters()];
        }
        oPopup.style.left = WpvPopup.offsetLeft + "px";
        oPopup.style.top = WpvPopup.offsetTop + "px";
        oPopup.style.display = "inline";
    },
    
    loadAdmin: function(sUri, sAction, oParameters) {
        var oPopup;
                
        if ((oPopup = document.getElementById("wpv-popup")) == null) {
            oPopup = document.createElement("div")
            oPopup.setAttribute("id", "wpv-popup")

            document.body.appendChild(oPopup)
        }
        
        if (oParameters == null)
            oParameters = new XmlRequestParameters();
        oParameters.add("action", sAction);
        oParameters.add("cookie", document.cookie);
        
        if (WpvPopup.cache[oParameters.getParameters()] == null) {
            WpvPopup.xmlRequest.cancelRequest();
            WpvPopup.xmlRequest.requestUri = sUri + "/wp-admin/admin-ajax.php";
            WpvPopup.xmlRequest.onRequestSent = WpvPopup.doRequestSent;
            WpvPopup.xmlRequest.onSuccess = WpvPopup.doRequestSuccess;
            WpvPopup.xmlRequest.onFailed = WpvPopup.doRequestFailed;
            WpvPopup.xmlRequest.onTimeOut = WpvPopup.doRequestFailed;
            WpvPopup.xmlRequest.onCanceled = WpvPopup.doRequestFailed;
            
            WpvPopup.xmlRequest.sendPostRequest(oParameters);
        }
        else {
            oPopup.innerHTML = WpvPopup.cache[oParameters.getParameters()];
        }
        oPopup.style.left = WpvPopup.offsetLeft + "px";
        oPopup.style.top = WpvPopup.offsetTop + "px";
        oPopup.style.display = "inline";
    },

    doRequestSent: function() {
        var oPopup;
        if ((oPopup = document.getElementById("wpv-popup")) != null) {
            oPopup.innerHTML = "<div style='padding: 10px 10px 10px 10px; border: 1px solid #000000;'>Loading...</div>";
        }
    },
    
    doRequestSuccess: function(oRequest, iStatus, sStatusText) {
        var oPopup;
        if ((oPopup = document.getElementById("wpv-popup")) != null) {
            if (WpvPopup.canMove)
                WpvMouse.makeDraggable(oPopup);
            oPopup.innerHTML = oRequest.getResponseText();
            WpvPopup.cache[oRequest.parameters] = oRequest.getResponseText();
        }
    },
    
    doRequestFailed: function() {
        var oPopup;
        if ((oPopup = document.getElementById("wpv-popup")) != null) {
            oPopup.innerHTML = "Failed to load data.";
        }
    }
}

var WindowSize = {
    getWidth: function() {
        if (typeof(window.innerWidth) == 'number') {
            //Non-IE
            return window.innerWidth;
        } 
        else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
            //IE 6+ in 'standards compliant mode'
            return document.documentElement.clientWidth;
        } 
        else if (document.body && (document.body.clientWidth || document.body.clientHeight)) {
            //IE 4 compatible
            return document.body.clientWidth;
        }
        else {
            return 0;
        }
    },
    
    getHeight: function() {
        if (typeof(window.innerWidth) == 'number') {
            //Non-IE
            return window.innerHeight;
        } 
        else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
            //IE 6+ in 'standards compliant mode'
            return document.documentElement.clientHeight;
        } 
        else if (document.body && (document.body.clientWidth || document.body.clientHeight)) {
            //IE 4 compatible
            return document.body.clientHeight;
        }
        else {
            return 0;
        }
    }
}

var ScrollXY = {
    getX: function() {
        if( typeof( window.pageYOffset ) == 'number' ) {
            //Netscape compliant
            return window.pageXOffset;
        }
        else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
            //DOM compliant
            return document.body.scrollLeft;
        }
        else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
            //IE6 standards compliant mode
            return document.documentElement.scrollLeft;
        }
        else {
            return 0;
        }
    },
    
    getY: function() {
        if( typeof( window.pageYOffset ) == 'number' ) {
            //Netscape compliant
            return window.pageYOffset;
        }
        else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
            //DOM compliant
            return document.body.scrollTop;
        }
        else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
            //IE6 standards compliant mode
            return document.documentElement.scrollTop;
        }
        else {
            return 0;
        }
    }
}

var WpvObjectOffset = {
    getOffsetLeft: function(obj, iLeft) {
        if (iLeft == null) {
            return WpvObjectOffset.getOffsetLeft(obj, obj.offsetLeft);
        }
        else if (obj.offsetParent != null) {
            return WpvObjectOffset.getOffsetLeft(obj.offsetParent, obj.offsetLeft + iLeft);
        }
        else {
            return iLeft;
        }
    },

    getOffsetTop: function(obj, iTop) {
        if (iTop == null) {
            return WpvObjectOffset.getOffsetTop(obj, obj.offsetTop);
        }
        else if (obj.offsetParent != null) {
            return WpvObjectOffset.getOffsetTop(obj.offsetParent, obj.offsetTop + iTop);
        }
        else {
            return iTop;
        }
    }
}

var WpvGrayOut = {
    show: function() {
        var oGrayArea = document.getElementById("wpv-gray-out");

        if (oGrayArea != null) {
            var iWidth;
            var iHeight;
            var oDropdownArray = document.getElementsByTagName("SELECT");
            
            // Hack to deal with IE6 bug where drop down comes through overlaying div element.
            for (var i = 0; i < oDropdownArray.length; i++) {
                oDropdownArray[i].style.visibility = "hidden";
            }

            document.body.style.width = oGrayArea.style.width;
            document.body.style.height = oGrayArea.style.height;
            document.getElementsByTagName("HTML")[0].style.overflow = "hidden";
            document.body.style.overflow = "hidden";

            iWidth = WindowSize.getWidth();
            iHeight = WindowSize.getHeight();

            if (iWidth > 0 || iHeight > 0) {
                oGrayArea.style.width = iWidth + "px";
                oGrayArea.style.height = iHeight + "px";
            }
            else {
                oGrayArea.style.width = "100%";
                oGrayArea.style.height = "100%";
            }
            oGrayArea.style.left = ScrollXY.getX() + "px";
            oGrayArea.style.top = ScrollXY.getY() + "px";
            oGrayArea.style.display = "block"; 

            window.onmousewheel = document.onmousewheel = function() {return false;};
        }
    },

    hide: function() {
        var oGrayArea = document.getElementById("wpv-gray-out");
        var oDropdownArray = document.getElementsByTagName("SELECT");
        
        // Hack to deal with IE6 bug where drop down comes through overlaying div element.
        for (var i = 0; i < oDropdownArray.length; i++) {
            oDropdownArray[i].style.visibility = "visible";
        }
        
        document.body.style.width = "";
        document.body.style.height = "";
        document.getElementsByTagName("HTML")[0].style.overflow = "auto";
        document.body.style.overflow = "auto";
        
        oGrayArea.style.display = "none";
        window.onmousewheel = document.onmousewheel = null;
        window.onclick = null;
        window.onmousedown = null;
    },
    
    resize: function(sNewWidth, sNewHeight) {
        var oGrayArea = document.getElementById("wpv-gray-out");

        if (oGrayArea != null) {
            if (sNewWidth != null) {
                oGrayArea.style.width = sNewWidth + "px";
            }
            if (sNewHeight != null) {
                oGrayArea.style.height = sNewHeight + "px";
            }
            document.body.style.width = oGrayArea.style.width;
            document.body.style.height = oGrayArea.style.height;
        }
    },
    
    scroll: function() {
        var oGrayArea = document.getElementById("wpv-gray-out");

        if (oGrayArea != null) {
            oGrayArea.style.left = ScrollXY.getX() + "px";
            oGrayArea.style.top = ScrollXY.getY() + "px";
        }
    }
}

var WpvDialog = {
    xmlRequest: new XmlRequest(),
    intervalId: 0,
    
    openDialog: function(sUri, sMethod, oParameters) {        
        window.onresize = this.adjustLocation.bind(this);

        this.xmlRequest.requestUri = sUri;
        this.xmlRequest.onRequestSent = this.doRequestSent.bind(this);
        this.xmlRequest.onSuccess = this.doRequestSuccess.bind(this);
        this.xmlRequest.onFailed = this.doRequestFailed.bind(this);
        this.xmlRequest.onTimeOut = this.doRequestFailed.bind(this);
        this.xmlRequest.onCanceled = this.doRequestFailed.bind(this);
        
        if (sMethod.toUpperCase() == "GET")
            this.xmlRequest.sendGetRequest(oParameters);
        else if (sMethod.toUpperCase() == "POST")
            this.xmlRequest.sendPostRequest(oParameters);
    },
    
    openAdminDialog: function(frm) {
        window.onresize = this.adjustLocation.bind(this);

        frm.cookie.value = document.cookie;
        this.xmlRequest.requestUri = frm.requestUri.value; 
        this.xmlRequest.onRequestSent = this.doRequestSent.bind(this);
        this.xmlRequest.onSuccess = this.doRequestSuccess.bind(this);
        this.xmlRequest.onFailed = this.doRequestFailed.bind(this);
        this.xmlRequest.onTimeOut = this.doRequestFailed.bind(this);
        this.xmlRequest.onCanceled = this.doRequestFailed.bind(this);
        this.xmlRequest.sendPostRequestFromForm(frm);
    },
    
    doRequestSent: function(oRequest) {
        this.showMessage("Please Wait...");
    },
    
    doRequestSuccess: function(oRequest, iStatus, sStatusText) {
        var oDialog = document.getElementById("wpv-modal-dialog");
        
        WpvMouse.makeDraggable(oDialog);
        oDialog.innerHTML = oRequest.getResponseText();
        this.adjustLocation(null);
    },
    
    doRequestFailed: function(oRequest, iStatus, sStatusText) {
        var oDialog = document.getElementById("wpv-modal-dialog");

        oDialog.innerHTML = sStatusText;
        oDialog.style.visibility = "visible";
        this.adjustLocation(null);
    },
    
    adjustLocation: function(e) {
        var obj = document.getElementById("wpv-modal-dialog");

        if (obj != null) {
            var iWidth = WindowSize.getWidth();
            var iHeight = WindowSize.getHeight();
            var iObjWidth = obj.offsetWidth;
            var iObjHeight = obj.offsetHeight;
            var iObjLeft = (iWidth - iObjWidth) / 2  + ScrollXY.getX();
            var iObjTop;

            WpvGrayOut.resize(iWidth, iHeight);
            iObjTop = 10 + ScrollXY.getY();
            if (obj.style.visibility != "visible") {
                obj.style.visibility = "visible";
                obj.style.top = iObjTop + "px";
            }

            if (iObjLeft + iObjWidth > iWidth - 10)
                obj.style.left = iWidth - iObjWidth + "px";
            else
                obj.style.left = (iObjLeft < 0 ? 0 : iObjLeft) + "px";
        }
    },

    closeDialog: function() {
        var oDialog = document.getElementById("wpv-modal-dialog");

        if (WpvDialog.intervalId > 0)
            clearInterval(WpvDialog.intervalId);
        WpvGrayOut.hide();
        oDialog.style.visibility = "hidden";
        oDialog.innerHTML = "";
        window.onresize = null;
        window.scroll = null;
        document.onmousemove = null;
        document.onmouseup = null;
    },
    
    showMessage: function(sMessage) {
        var oDialog = document.getElementById("wpv-modal-dialog");

        oDialog.innerHTML = "<div class='dialog-message'>" + sMessage + "</div>";
        WpvGrayOut.show();
        this.adjustLocation(null);
        
        WpvDialog.intervalId = setInterval(function() {WpvGrayOut.resize(WindowSize.getWidth(), WindowSize.getHeight()); WpvGrayOut.scroll(); }, 500);
    }
}
